import DataRow from "./data_row";
import GetItemsResult from "./get_items_result";
export default abstract class BaseDataMapper<T extends DataRow> {
    abstract getItems(filter?: any): Promise<GetItemsResult<T>>;
    abstract getItem(key: string): Promise<T | null>;
    abstract insert(payload: any): Promise<T>;
    abstract update(key: string, payload: any): Promise<boolean>;
    abstract delete(key: string): Promise<boolean>;
    abstract get KEY_FIELD_NAME(): string;
    protected abstract get fieldMap(): Map<string, any>;
    protected convertCollection(data: Array<any>): Array<T>;
    protected map(payload: any): T;
    protected abstract factory(key: string): T;
}
